﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Workflow.Runtime;
using System.Workflow.Runtime.Hosting;
using SequentialWorkflowInputOutputTestConsole.Entities;

namespace SequentialWorkflowInputOutputTestConsole
{
    class Program
    {
        static void Main(string[] args)
        {
            using(WorkflowRuntime workflowRuntime = new WorkflowRuntime())
            {
                AutoResetEvent waitHandle = new AutoResetEvent(false);
                workflowRuntime.WorkflowCompleted += delegate(object sender, WorkflowCompletedEventArgs e) {waitHandle.Set();};
                workflowRuntime.WorkflowTerminated += delegate(object sender, WorkflowTerminatedEventArgs e)
                {
                    Console.WriteLine(e.Exception.Message);
                    waitHandle.Set();
                };

                Dictionary<string, object> argumentsDictionary = new Dictionary<string, object>();
                argumentsDictionary.Add("Product", new ProductInfo { Id = 0, Name = "Product in Program.Main", Price = 0 });

                WorkflowInstance instance = workflowRuntime.CreateWorkflow(typeof(SequentialWorkflowInputOutputTestConsole.Workflow1),argumentsDictionary);
                instance.Start();

                waitHandle.WaitOne();
            }

            Console.ReadKey();
        }
    }
}
